/********

Syed S. Ullah
ID # 000-97-4716
Homework 2
Language: Java
Compiler: javac
Last modified: Oct 19, 1999

********/

import java.util.*;
import java.io.*;


public class Association
   {
   Database automobile = new Database(); // Stores the database
	Vector	largeSet = new Vector(8); // Stores large item sets  
	/***************************************************************
	This function calls the generateRules function in order to
	generate the rules.
	****************************************************************/
	public void generateAssocRules()
		{
		System.out.println("Association Rules:");
		for (int i = 1; i < largeSet.size(); ++i)
			{
			LargeItemset L = (LargeItemset) largeSet.elementAt(i);
			L.generateRules(i, largeSet, automobile);
			}
		}
	/***************************************************************
	This function reads each line from the input file and sends it to
	the populate method of the automobile object.
	****************************************************************/
   public void loadData(DataInputStream in) throws IOException
	{
 	String line;
	int lineCount = 0;

	line = in.readLine();
	while (line != null)
	   {
	   ++lineCount;
	   automobile.populate(line, lineCount);
	   line = in.readLine();
	   }	
	automobile.populateDistinctVectors();
	}
   /***************************************************************
	This function creates the large itemset of size k.
   ****************************************************************/
	public void populateLargeItemset(int k)
		{
		if (k == 1) // first itemset containing single items
			{
			LargeItemset L1 = new LargeItemset(1);
			L1.populateWithSingle(automobile);
		   largeSet.addElement(L1); 	
			}
		else	// size 2 and greater
			{
			for ( ; k < 9 && largeSet.size()+1 == k; ++k)
				{
				LargeItemset Lk = new LargeItemset(k);
				Lk.populate((LargeItemset) largeSet.elementAt(k-2), automobile);
				if (Lk.getLength() > 0) // prev itemse not
							// null
					largeSet.addElement(Lk);
				}
			}
		}
	/***************************************************************
	This function prints the database.
	****************************************************************/
	public void printDatabase()
		{
		automobile.printDatabase();
		}
	/***************************************************************
	This function prints the contents of the large itemsets.
	***************************************************************/
	public 	void	printLargeItemsets()
		{
		for (int i = 0; i < largeSet.size(); ++i)
			{		
			LargeItemset L	= (LargeItemset) largeSet.elementAt(i);
			L.print();
			}
		}
   /*******************************************************************/
	public static void main(String[] args)
   	{
   	Association assoc = new Association();

		System.out.println("Processing.......");
		try 
	   	{
	   	DataInputStream in = new DataInputStream (new FileInputStream
			("automobile.dat"));
	   	assoc.loadData(in);
	   	}
		catch (IOException e)
	   	{
	   	System.out.print("Error" + e);
	   	System.exit(1);
	   	}
		// assoc.printDatabase(); // database contents
		assoc.populateLargeItemset(1);
		assoc.populateLargeItemset(2);
		// assoc.printLargeItemsets(); // itemset contents
		assoc.generateAssocRules();
		}
} // class 
