import java.util.*;
import java.io.*;

public class Database
   {
   Vector 	databaseTuples = new Vector(300, 50); 
	Vector 	distinctOrigins = new Vector(5, 5);
	Vector 	distinctCylinders = new Vector(7, 2);
	Vector	distinctMpgs = new Vector (10, 3);
	Vector	distinctAccelerations = new Vector (30, 5);
	Vector 	distinctModelYears = new Vector (20, 5);
	Vector	distinctDisplacements = new Vector (30, 10);
	Vector	distinctHorsePowers = new Vector (30, 10);
 	Vector	distinctWeights = new Vector (100, 50);  
	/***************************************************************
	This function return the number of rows in the database where the
	attribute values sent through the fields vector have a match.
	****************************************************************/
	public int 	getCount(Vector fields)
		{
		Tuple tpl = new Tuple();
		int index, count = 0;
		char rowtype;
		String fieldValue, attributeValue;
		boolean match;

		for (int i = 0; i < databaseTuples.size(); ++i) 
			{
			match = true;

			tpl = (Tuple) databaseTuples.elementAt(i);
			for (int j = 0; j < fields.size() && match == true; ++j)
				{
			 	fieldValue = (String) fields.elementAt(j);	
				index = fieldValue.indexOf('(');
				rowtype = fieldValue.charAt(index + 1);
				attributeValue = tpl.returnAttributeValue(rowtype);
				if (attributeValue.equals(fieldValue) == false)
					match = false;
				}
			if (match == true) // exact match found
				++count;
			}
		return count;
		}
	/***************************************************************
	This function finds all the possible values for each column in
	the database and stored them in the vectors declared at the 
	beginning of the class
	****************************************************************/
	public	void 	populateDistinctVectors()
		{
		for (int i = 0; i < databaseTuples.size(); ++i)
			{
			String	field;
			Tuple tpl = (Tuple) databaseTuples.elementAt(i);

			field = tpl.returnAttributeValue('o');
			if (distinctOrigins.contains(field) == false)	
				distinctOrigins.addElement(field);
			field = tpl.returnAttributeValue('c');
			if (distinctCylinders.contains(field) == false)
				distinctCylinders.addElement(field);
			field = tpl.returnAttributeValue('m');
			if (distinctMpgs.contains(field) == false)
				distinctMpgs.addElement(field);
			field = tpl.returnAttributeValue('a');
			if (distinctAccelerations.contains(field) == false)
				distinctAccelerations.addElement(field);
			field = tpl.returnAttributeValue('y');
			if (distinctModelYears.contains(field) == false)
				distinctModelYears.addElement(field);
			field = tpl.returnAttributeValue('d');
			if (distinctDisplacements.contains(field) == false)
				distinctDisplacements.addElement(field);
			field = tpl.returnAttributeValue('h');
			if (distinctHorsePowers.contains(field) == false)
				distinctHorsePowers.addElement(field);
			field = tpl.returnAttributeValue('w');
			if (distinctWeights.contains(field) == false)
				distinctWeights.addElement(field);
			}	
		}
	/***************************************************************/
	
   public	Vector getDistinctModelYears() { return distinctModelYears; }
   public	Vector getDistinctCylinders() { return distinctCylinders; }
   public	Vector getDistinctWeights() { return distinctWeights; }  
   public	Vector getDistinctMpgs() { return distinctMpgs; }
   public	Vector getDistinctOrigins() { return distinctOrigins; }
   public	Vector getDistinctHorsePowers() { return distinctHorsePowers; }
   public	Vector getDistinctDisplacements() { return distinctDisplacements; }
   public	Vector getDistinctAccelerations() { return distinctAccelerations; } 

   /***************************************************************
	This function is used to populate one row of the database reading
	values from the input file.
   ****************************************************************/
   public void populate(String line, int lineCount)
		{
		Tuple 	nextRecord = new Tuple(line, lineCount);

		databaseTuples.addElement(nextRecord);	
		}
	/***************************************************************
	Prints the contents of the database.
	****************************************************************/
	public void printDatabase()
		{
		int i;

		for (i = 0; i < databaseTuples.size(); ++i) // each tuple
			{
			Tuple tpl = (Tuple) databaseTuples.elementAt(i);
			tpl.printTuple();
			}
		}
   }
