import java.util.*;
import java.io.*;


public class Item
	{
	Vector members = new Vector(1, 1); // members of each set in the
					   // large itemset
	int support;	// support for the set
	/***************************************************************
	Constructor function initializes each item for large itemset 
	where k = 1	
	****************************************************************/
	Item(String str, int supp)
		{
		support = supp;
		members.addElement(str);
		}
	/***************************************************************
	This constructor function initializes each item for large itemset
	where k > 1
	****************************************************************/
	Item (Vector temp, int supp)
		{
		support = supp;
		members = temp;
		}
	/***************************************************************
	Returns the (i+1)th attribute value of a set from the large 
	itemset
	****************************************************************/
	public String	getElementAt(int i)
		{
		return (String) members.elementAt(i);
		}
	/***************************************************************
	Returns a set from the large itemset
	****************************************************************/
	public Vector	getMember()
		{
		return members;
		}
	/***************************************************************
	Prints the contents of a set from the large itemset
	****************************************************************/
	public void print()
		{
		for (int i = 0; i < members.size(); ++i)
			{
			String attribute = (String) members.elementAt(i);
			System.out.print("("+attribute+","+support+")");
			}	
		System.out.println();
		}	
	/***************************************************************
	Returns the support for a set in the largeitemset.
	****************************************************************/
	public int getSupport()
		{
		return support;
		}
	} 
